submodule: document module_clone arguments in comments
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
cf419828 11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
06b1abb5 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
5c08dbbd 25command=
ecda0723 26branch=
d27b876b 27force=
d92a3959 28reference=
70c7ac22 29cached=
48bb3033
GP
30recursive=
31init=
1c244f6e 32files=
06b1abb5 33remote=
31ca3ac3 34nofetch=
32948425 35update=
15fc56a8 36prefix=
73b0898d 37custom_name=
275cd184 38depth=
70c7ac22 39
967b2c66
JS
40# The function takes at most 2 arguments. The first argument is the
41# URL that navigates to the submodule origin repo. When relative, this URL
42# is relative to the superproject origin URL repo. The second up_path
43# argument, if specified, is the relative path that navigates
44# from the submodule working tree to the superproject working tree.
45#
46# The output of the function is the origin URL of the submodule.
47#
48# The output will either be an absolute URL or filesystem path (if the
49# superproject origin URL is an absolute URL or filesystem path,
50# respectively) or a relative file system path (if the superproject
51# origin URL is a relative file system path).
52#
53# When the output is a relative file system path, the path is either
54# relative to the submodule working tree, if up_path is specified, or to
55# the superproject working tree otherwise.
f31a522a
ML
56resolve_relative_url ()
57{
98fcf840 58 remote=$(get_default_remote)
8e7e6f39 59 remoteurl=$(git config "remote.$remote.url") ||
4d689320 60 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 61 url="$1"
99b120af 62 remoteurl=${remoteurl%/}
ea640cc6 63 sep=/
967b2c66
JS
64 up_path="$2"
65
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
69 ;;
758615e2
JS
70 ./*|../*)
71 is_relative=t
72 ;;
967b2c66
JS
73 *)
74 is_relative=t
758615e2 75 remoteurl="./$remoteurl"
967b2c66
JS
76 ;;
77 esac
78
f31a522a
ML
79 while test -n "$url"
80 do
81 case "$url" in
82 ../*)
83 url="${url#../}"
ea640cc6
TR
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
87 ;;
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
91 ;;
92 *)
758615e2
JS
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
98 fi
ea640cc6
TR
99 ;;
100 esac
f31a522a
ML
101 ;;
102 ./*)
103 url="${url#./}"
104 ;;
105 *)
106 break;;
107 esac
108 done
758615e2
JS
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
f31a522a
ML
111}
112
091a6eb0
JK
113# Resolve a path to be relative to another path. This is intended for
114# converting submodule paths when git-submodule is run in a subdirectory
115# and only handles paths where the directory separator is '/'.
116#
117# The output is the first argument as a path relative to the second argument,
118# which defaults to $wt_prefix if it is omitted.
119relative_path ()
120{
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
126
127 while test -n "$curdir"
128 do
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
133 ;;
134 esac
135
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
142 fi
143 done
144
145 echo "$result$target"
146}
147
a7b3269c
DA
148#
149# Get submodule info for registered submodules
150# $@ = path to limit submodule list
151#
152module_list()
153{
091a6eb0 154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
be9d0a3a 155 (
74671241 156 git ls-files -z --error-unmatch --stage -- "$@" ||
be9d0a3a
HV
157 echo "unmatched pathspec exists"
158 ) |
313ee0d6
NMC
159 perl -e '
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
be9d0a3a
HV
162 my @out = ();
163 my $unmatched = 0;
74671241 164 $/ = "\0";
313ee0d6 165 while (<STDIN>) {
be9d0a3a
HV
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
169 }
313ee0d6
NMC
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
be9d0a3a 176 push @out, "$mode $null_sha1 U\t$path\n";
313ee0d6
NMC
177 }
178 next;
179 }
be9d0a3a
HV
180 push @out, "$_\n";
181 }
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
313ee0d6
NMC
186 }
187 '
a7b3269c
DA
188}
189
be9d0a3a
HV
190die_if_unmatched ()
191{
192 if test "$1" = "#unmatched"
193 then
194 exit 1
195 fi
196}
197
88ce00c3
TK
198#
199# Print a submodule configuration setting
200#
201# $1 = submodule name
202# $2 = option name
203# $3 = default value
204#
205# Checks in the usual git-config places first (for overrides),
206# otherwise it falls back on .gitmodules. This allows you to
207# distribute project-wide defaults in .gitmodules, while still
208# customizing individual repositories if necessary. If the option is
209# not in .gitmodules either, print a default value.
210#
211get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
219 fi
220 printf '%s' "${value:-$default}"
221}
222
223
941987a5
LH
224#
225# Map submodule path to submodule name
226#
227# $1 = path
228#
229module_name()
230{
537601ac 231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64394e3a 232 sm_path="$1"
fe22e542 233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a 236 test -z "$name" &&
64394e3a 237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
1e42258a 238 echo "$name"
941987a5 239}
33aa6fff
LH
240
241#
242# Clone a submodule
243#
9adfc1cf
TK
244# $1 = submodule path
245# $2 = submodule name
246# $3 = URL to clone
247# $4 = reference repository to reuse (empty for independent)
248# $5 = depth argument for shallow clones (empty for deep)
249#
23a485e3 250# Prior to calling, cmd_update checks that a possibly existing
ecda0723 251# path is not a git repository.
23a485e3 252# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
253# since it is the location of a new submodule.
254#
33aa6fff
LH
255module_clone()
256{
64394e3a 257 sm_path=$1
73b0898d
JL
258 name=$2
259 url=$3
260 reference="$4"
275cd184 261 depth="$5"
7e60407f
JL
262 quiet=
263 if test -n "$GIT_QUIET"
264 then
265 quiet=-q
266 fi
33aa6fff 267
501770e1
FG
268 gitdir=
269 gitdir_base=
69c30517 270 base_name=$(dirname "$name")
33aa6fff 271
501770e1 272 gitdir=$(git rev-parse --git-dir)
69c30517
JL
273 gitdir_base="$gitdir/modules/$base_name"
274 gitdir="$gitdir/modules/$name"
501770e1
FG
275
276 if test -d "$gitdir"
d92a3959 277 then
64394e3a 278 mkdir -p "$sm_path"
501770e1 279 rm -f "$gitdir/index"
d92a3959 280 else
501770e1 281 mkdir -p "$gitdir_base"
be8779f7
DG
282 (
283 clear_local_git_env
275cd184 284 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
be8779f7
DG
285 --separate-git-dir "$gitdir" "$url" "$sm_path"
286 ) ||
64394e3a 287 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
501770e1 288 fi
ea115a0d 289
6eafa6d0
JL
290 # We already are at the root of the work tree but cd_to_toplevel will
291 # resolve any symlinks that might be present in $PWD
292 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
15b3c82c 293 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
4dce7d9b
JS
294 # normalize Windows-style absolute paths to POSIX-style absolute paths
295 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
296 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
d75219b4
JL
297 # Remove all common leading directories after a sanity check
298 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
299 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
300 fi
301 while test "${a%%/*}" = "${b%%/*}"
302 do
303 a=${a#*/}
304 b=${b#*/}
305 done
306 # Now chop off the trailing '/'s that were added in the beginning
307 a=${a%/}
308 b=${b%/}
309
c5bc42b9
BW
310 # Turn each leading "*/" component into "../"
311 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
64394e3a 312 echo "gitdir: $rel/$a" >"$sm_path/.git"
69c30517 313
c5bc42b9 314 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
64394e3a 315 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
33aa6fff
LH
316}
317
862ae6cd
RS
318isnumber()
319{
320 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
321}
322
ecda0723
SV
323#
324# Add a new submodule to the working tree, .gitmodules and the index
325#
ec05df35 326# $@ = repo path
ecda0723
SV
327#
328# optional branch is stored in global branch variable
329#
23a485e3 330cmd_add()
ecda0723 331{
5c08dbbd 332 # parse $args after "submodule ... add".
091a6eb0 333 reference_path=
5c08dbbd
JH
334 while test $# -ne 0
335 do
336 case "$1" in
337 -b | --branch)
338 case "$2" in '') usage ;; esac
339 branch=$2
340 shift
341 ;;
d27b876b
JL
342 -f | --force)
343 force=$1
344 ;;
5c08dbbd 345 -q|--quiet)
2e6a30ef 346 GIT_QUIET=1
5c08dbbd 347 ;;
d92a3959
MT
348 --reference)
349 case "$2" in '') usage ;; esac
091a6eb0 350 reference_path=$2
d92a3959
MT
351 shift
352 ;;
353 --reference=*)
091a6eb0 354 reference_path="${1#--reference=}"
d92a3959 355 ;;
73b0898d
JL
356 --name)
357 case "$2" in '') usage ;; esac
358 custom_name=$2
359 shift
360 ;;
275cd184
FG
361 --depth)
362 case "$2" in '') usage ;; esac
363 depth="--depth=$2"
364 shift
365 ;;
366 --depth=*)
367 depth=$1
368 ;;
5c08dbbd
JH
369 --)
370 shift
371 break
372 ;;
373 -*)
374 usage
375 ;;
376 *)
377 break
378 ;;
379 esac
380 shift
381 done
382
091a6eb0
JK
383 if test -n "$reference_path"
384 then
385 is_absolute_path "$reference_path" ||
386 reference_path="$wt_prefix$reference_path"
387
388 reference="--reference=$reference_path"
389 fi
390
ecda0723 391 repo=$1
64394e3a 392 sm_path=$2
ecda0723 393
64394e3a
RJ
394 if test -z "$sm_path"; then
395 sm_path=$(echo "$repo" |
1414e578
JL
396 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
397 fi
398
64394e3a 399 if test -z "$repo" -o -z "$sm_path"; then
ecda0723
SV
400 usage
401 fi
402
091a6eb0
JK
403 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
404
ec05df35
ML
405 # assure repo is absolute or relative to parent
406 case "$repo" in
407 ./*|../*)
091a6eb0
JK
408 test -z "$wt_prefix" ||
409 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
410
ec05df35
ML
411 # dereference source url relative to parent's url
412 realrepo=$(resolve_relative_url "$repo") || exit
413 ;;
414 *:*|/*)
415 # absolute url
416 realrepo=$repo
417 ;;
418 *)
497ee872 419 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
420 ;;
421 esac
422
db75ada5
MG
423 # normalize path:
424 # multiple //; leading ./; /./; /../; trailing /
64394e3a 425 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
426 sed -e '
427 s|//*|/|g
428 s|^\(\./\)*||
429 s|/\./|/|g
430 :start
431 s|\([^/]*\)/\.\./||
432 tstart
433 s|/*$||
434 ')
64394e3a
RJ
435 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
436 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 437
64394e3a 438 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 439 then
6ff875c5 440 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 441\$sm_path
6ff875c5 442Use -f if you really want to add it." >&2
d27b876b
JL
443 exit 1
444 fi
445
73b0898d
JL
446 if test -n "$custom_name"
447 then
448 sm_name="$custom_name"
449 else
450 sm_name="$sm_path"
451 fi
452
d4264ca3 453 # perhaps the path exists and is already a git repo, else clone it
64394e3a 454 if test -e "$sm_path"
d4264ca3 455 then
64394e3a 456 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
d4264ca3 457 then
64394e3a 458 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 459 else
64394e3a 460 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 461 fi
c2f93917 462
d4264ca3 463 else
4b7c286e
JL
464 if test -d ".git/modules/$sm_name"
465 then
466 if test -z "$force"
467 then
468 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
469 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
470 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
471 echo >&2 " $realrepo"
472 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
473 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
474 else
475 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
476 fi
477 fi
275cd184 478 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
ea10b60c 479 (
74ae1419 480 clear_local_git_env
64394e3a 481 cd "$sm_path" &&
ea10b60c
BJ
482 # ash fails to wordsplit ${branch:+-b "$branch"...}
483 case "$branch" in
484 '') git checkout -f -q ;;
502dc5b6 485 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 486 esac
64394e3a 487 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 488 fi
73b0898d 489 git config submodule."$sm_name".url "$realrepo"
d4264ca3 490
64394e3a
RJ
491 git add $force "$sm_path" ||
492 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 493
73b0898d
JL
494 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
495 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
496 if test -n "$branch"
497 then
498 git config -f .gitmodules submodule."$sm_name".branch "$branch"
499 fi &&
31991b02 500 git add --force .gitmodules ||
64394e3a 501 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
502}
503
19a31f9c
ML
504#
505# Execute an arbitrary command sequence in each checked out
506# submodule
507#
508# $@ = command to execute
509#
510cmd_foreach()
511{
1d5bec8b
JH
512 # parse $args after "submodule ... foreach".
513 while test $# -ne 0
514 do
515 case "$1" in
516 -q|--quiet)
517 GIT_QUIET=1
518 ;;
15fc56a8
JH
519 --recursive)
520 recursive=1
521 ;;
1d5bec8b
JH
522 -*)
523 usage
524 ;;
525 *)
526 break
527 ;;
528 esac
529 shift
530 done
531
f030c96d
ÆAB
532 toplevel=$(pwd)
533
4dca1aa6
BC
534 # dup stdin so that it can be restored when running the external
535 # command in the subshell (and a recursive call to this function)
536 exec 3<&0
537
a7b3269c 538 module_list |
64394e3a 539 while read mode sha1 stage sm_path
19a31f9c 540 do
be9d0a3a 541 die_if_unmatched "$mode"
64394e3a 542 if test -e "$sm_path"/.git
19a31f9c 543 then
091a6eb0
JK
544 displaypath=$(relative_path "$sm_path")
545 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
64394e3a 546 name=$(module_name "$sm_path")
15fc56a8 547 (
64394e3a 548 prefix="$prefix$sm_path/"
74ae1419 549 clear_local_git_env
64394e3a 550 cd "$sm_path" &&
091a6eb0
JK
551 sm_path=$(relative_path "$sm_path") &&
552 # we make $path available to scripts ...
553 path=$sm_path &&
15fc56a8
JH
554 eval "$@" &&
555 if test -n "$recursive"
556 then
557 cmd_foreach "--recursive" "$@"
558 fi
4dca1aa6 559 ) <&3 3<&- ||
091a6eb0 560 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
561 fi
562 done
563}
564
70c7ac22 565#
211b7f19 566# Register submodules in .git/config
70c7ac22
LH
567#
568# $@ = requested paths (default to all)
569#
23a485e3 570cmd_init()
70c7ac22 571{
5c08dbbd
JH
572 # parse $args after "submodule ... init".
573 while test $# -ne 0
574 do
575 case "$1" in
576 -q|--quiet)
2e6a30ef 577 GIT_QUIET=1
5c08dbbd
JH
578 ;;
579 --)
580 shift
581 break
582 ;;
583 -*)
584 usage
585 ;;
586 *)
587 break
588 ;;
589 esac
590 shift
591 done
592
a7b3269c 593 module_list "$@" |
64394e3a 594 while read mode sha1 stage sm_path
70c7ac22 595 do
be9d0a3a 596 die_if_unmatched "$mode"
64394e3a 597 name=$(module_name "$sm_path") || exit
c1c259e2 598
091a6eb0
JK
599 displaypath=$(relative_path "$sm_path")
600
c1c259e2 601 # Copy url setting when it is not set yet
2cd9de3e
JL
602 if test -z "$(git config "submodule.$name.url")"
603 then
604 url=$(git config -f .gitmodules submodule."$name".url)
605 test -z "$url" &&
091a6eb0 606 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
2cd9de3e
JL
607
608 # Possibly a url relative to parent
609 case "$url" in
610 ./*|../*)
611 url=$(resolve_relative_url "$url") || exit
612 ;;
613 esac
614 git config submodule."$name".url "$url" ||
091a6eb0 615 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
c1c259e2 616
091a6eb0 617 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
2cd9de3e 618 fi
70c7ac22 619
2cd9de3e 620 # Copy "update" setting when it is not set yet
ac1fbbda
JH
621 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
622 test -n "$upd" &&
623 test -z "$(git config submodule."$name".update)"
624 then
625 case "$upd" in
efa8fd7e 626 checkout | rebase | merge | none)
ac1fbbda
JH
627 ;; # known modes of updating
628 *)
629 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
630 upd=none
631 ;;
632 esac
633 git config submodule."$name".update "$upd" ||
634 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
635 fi
70c7ac22
LH
636 done
637}
638
cf419828
JL
639#
640# Unregister submodules from .git/config and remove their work tree
641#
642# $@ = requested paths (use '.' to deinit all submodules)
643#
644cmd_deinit()
645{
646 # parse $args after "submodule ... deinit".
647 while test $# -ne 0
648 do
649 case "$1" in
650 -f|--force)
651 force=$1
652 ;;
653 -q|--quiet)
654 GIT_QUIET=1
655 ;;
656 --)
657 shift
658 break
659 ;;
660 -*)
661 usage
662 ;;
663 *)
664 break
665 ;;
666 esac
667 shift
668 done
669
670 if test $# = 0
671 then
672 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
673 fi
674
675 module_list "$@" |
676 while read mode sha1 stage sm_path
677 do
678 die_if_unmatched "$mode"
679 name=$(module_name "$sm_path") || exit
680
091a6eb0
JK
681 displaypath=$(relative_path "$sm_path")
682
cf419828
JL
683 # Remove the submodule work tree (unless the user already did it)
684 if test -d "$sm_path"
685 then
686 # Protect submodules containing a .git directory
687 if test -d "$sm_path/.git"
688 then
091a6eb0 689 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
690 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
691 fi
692
693 if test -z "$force"
694 then
7b294bf4 695 git rm -qn "$sm_path" ||
091a6eb0 696 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 697 fi
7b294bf4 698 rm -rf "$sm_path" &&
091a6eb0
JK
699 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
700 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
701 fi
702
091a6eb0 703 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
704
705 # Remove the .git/config entries (unless the user already did it)
706 if test -n "$(git config --get-regexp submodule."$name\.")"
707 then
708 # Remove the whole section so we have a clean state when
709 # the user later decides to init this submodule again
710 url=$(git config submodule."$name".url)
711 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 712 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
713 fi
714 done
715}
716
70c7ac22 717#
211b7f19 718# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
719#
720# $@ = requested paths (default to all)
721#
23a485e3 722cmd_update()
70c7ac22 723{
5c08dbbd 724 # parse $args after "submodule ... update".
98dbe63d 725 orig_flags=
5c08dbbd
JH
726 while test $# -ne 0
727 do
728 case "$1" in
729 -q|--quiet)
2e6a30ef 730 GIT_QUIET=1
5c08dbbd 731 ;;
be4d2c83 732 -i|--init)
d92a3959 733 init=1
be4d2c83 734 ;;
06b1abb5
TK
735 --remote)
736 remote=1
737 ;;
31ca3ac3 738 -N|--no-fetch)
31ca3ac3
FF
739 nofetch=1
740 ;;
9db31bdf
NMC
741 -f|--force)
742 force=$1
743 ;;
ca2cedba 744 -r|--rebase)
32948425 745 update="rebase"
ca2cedba 746 ;;
d92a3959
MT
747 --reference)
748 case "$2" in '') usage ;; esac
749 reference="--reference=$2"
98dbe63d
KB
750 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
751 shift
d92a3959
MT
752 ;;
753 --reference=*)
754 reference="$1"
d92a3959 755 ;;
42b49178 756 -m|--merge)
42b49178
JH
757 update="merge"
758 ;;
b13fd5c1 759 --recursive)
b13fd5c1
JH
760 recursive=1
761 ;;
efc5fb6a
JH
762 --checkout)
763 update="checkout"
764 ;;
275cd184
FG
765 --depth)
766 case "$2" in '') usage ;; esac
767 depth="--depth=$2"
768 shift
769 ;;
770 --depth=*)
771 depth=$1
772 ;;
5c08dbbd
JH
773 --)
774 shift
775 break
776 ;;
777 -*)
778 usage
779 ;;
780 *)
781 break
782 ;;
783 esac
98dbe63d
KB
784 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
785 shift
5c08dbbd
JH
786 done
787
d92a3959
MT
788 if test -n "$init"
789 then
790 cmd_init "--" "$@" || return
791 fi
792
1b4735d9 793 cloned_modules=
15ffb7cd
FG
794 module_list "$@" | {
795 err=
64394e3a 796 while read mode sha1 stage sm_path
70c7ac22 797 do
be9d0a3a 798 die_if_unmatched "$mode"
313ee0d6
NMC
799 if test "$stage" = U
800 then
75bf5e60 801 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
313ee0d6
NMC
802 continue
803 fi
64394e3a 804 name=$(module_name "$sm_path") || exit
5be60078 805 url=$(git config submodule."$name".url)
06b1abb5 806 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
807 if ! test -z "$update"
808 then
809 update_module=$update
810 else
811 update_module=$(git config submodule."$name".update)
a2aed08b
TK
812 if test -z "$update_module"
813 then
814 update_module="checkout"
815 fi
efc5fb6a
JH
816 fi
817
091a6eb0
JK
818 displaypath=$(relative_path "$prefix$sm_path")
819
efc5fb6a
JH
820 if test "$update_module" = "none"
821 then
091a6eb0 822 echo "Skipping submodule '$displaypath'"
efc5fb6a
JH
823 continue
824 fi
825
211b7f19 826 if test -z "$url"
70c7ac22
LH
827 then
828 # Only mention uninitialized submodules when its
829 # path have been specified
830 test "$#" != "0" &&
091a6eb0 831 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
1c2ef66f 832Maybe you want to use 'update --init'?")"
211b7f19
LH
833 continue
834 fi
835
64394e3a 836 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
211b7f19 837 then
275cd184 838 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
1b4735d9 839 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
840 subsha1=
841 else
64394e3a 842 subsha1=$(clear_local_git_env; cd "$sm_path" &&
5be60078 843 git rev-parse --verify HEAD) ||
091a6eb0 844 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 845 fi
211b7f19 846
06b1abb5
TK
847 if test -n "$remote"
848 then
849 if test -z "$nofetch"
850 then
851 # Fetch remote before determining tracking $sha1
852 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
853 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
854 fi
855 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
856 sha1=$(clear_local_git_env; cd "$sm_path" &&
857 git rev-parse --verify "${remote_name}/${branch}") ||
858 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
859 fi
860
01d47215 861 if test "$subsha1" != "$sha1" -o -n "$force"
70c7ac22 862 then
9db31bdf
NMC
863 subforce=$force
864 # If we don't already have a -f flag and the submodule has never been checked out
865 if test -z "$subsha1" -a -z "$force"
b9b378a0 866 then
9db31bdf 867 subforce="-f"
b9b378a0 868 fi
31ca3ac3
FF
869
870 if test -z "$nofetch"
871 then
e5f522d6
JL
872 # Run fetch only if $sha1 isn't present or it
873 # is not reachable from a ref.
64394e3a 874 (clear_local_git_env; cd "$sm_path" &&
f5799e05 875 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 876 test -z "$rev") || git-fetch)) ||
091a6eb0 877 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
31ca3ac3
FF
878 fi
879
1b4735d9
SO
880 # Is this something we just cloned?
881 case ";$cloned_modules;" in
882 *";$name;"*)
883 # then there is no local change to integrate
a2aed08b 884 update_module=checkout ;;
1b4735d9
SO
885 esac
886
877449c1 887 must_die_on_failure=
32948425 888 case "$update_module" in
a2aed08b
TK
889 checkout)
890 command="git checkout $subforce -q"
891 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
892 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
893 ;;
32948425
JH
894 rebase)
895 command="git rebase"
091a6eb0
JK
896 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
897 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 898 must_die_on_failure=yes
32948425 899 ;;
42b49178
JH
900 merge)
901 command="git merge"
091a6eb0
JK
902 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
903 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 904 must_die_on_failure=yes
42b49178 905 ;;
6cb5728c
CP
906 !*)
907 command="${update_module#!}"
908 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
909 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
910 must_die_on_failure=yes
911 ;;
32948425 912 *)
a2aed08b 913 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 914 esac
70c7ac22 915
64394e3a 916 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 917 then
ff968f03 918 say "$say_msg"
877449c1
JH
919 elif test -n "$must_die_on_failure"
920 then
ff968f03 921 die_with_status 2 "$die_msg"
15ffb7cd 922 else
ff968f03 923 err="${err};$die_msg"
877449c1 924 continue
15ffb7cd 925 fi
70c7ac22 926 fi
b13fd5c1
JH
927
928 if test -n "$recursive"
929 then
75bf5e60
WE
930 (
931 prefix="$prefix$sm_path/"
932 clear_local_git_env
933 cd "$sm_path" &&
934 eval cmd_update "$orig_flags"
935 )
15ffb7cd
FG
936 res=$?
937 if test $res -gt 0
938 then
091a6eb0 939 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
940 if test $res -eq 1
941 then
ff968f03 942 err="${err};$die_msg"
15ffb7cd
FG
943 continue
944 else
ff968f03 945 die_with_status $res "$die_msg"
15ffb7cd
FG
946 fi
947 fi
b13fd5c1 948 fi
70c7ac22 949 done
15ffb7cd
FG
950
951 if test -n "$err"
952 then
953 OIFS=$IFS
954 IFS=';'
955 for e in $err
956 do
957 if test -n "$e"
958 then
959 echo >&2 "$e"
960 fi
961 done
962 IFS=$OIFS
963 exit 1
964 fi
965 }
70c7ac22
LH
966}
967
bffe71f4
EM
968set_name_rev () {
969 revname=$( (
74ae1419 970 clear_local_git_env
bffe71f4 971 cd "$1" && {
5be60078
JH
972 git describe "$2" 2>/dev/null ||
973 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
974 git describe --contains "$2" 2>/dev/null ||
975 git describe --all --always "$2"
bffe71f4
EM
976 }
977 ) )
978 test -z "$revname" || revname=" ($revname)"
979}
28f9af5d
PY
980#
981# Show commit summary for submodules in index or working tree
982#
983# If '--cached' is given, show summary between index and given commit,
984# or between working tree and given commit
985#
986# $@ = [commit (default 'HEAD'),] requested paths (default all)
987#
988cmd_summary() {
f2dc06a3 989 summary_limit=-1
d0f64dd4 990 for_status=
1c244f6e 991 diff_cmd=diff-index
f2dc06a3 992
28f9af5d
PY
993 # parse $args after "submodule ... summary".
994 while test $# -ne 0
995 do
996 case "$1" in
997 --cached)
998 cached="$1"
999 ;;
1c244f6e
JL
1000 --files)
1001 files="$1"
1002 ;;
d0f64dd4
PY
1003 --for-status)
1004 for_status="$1"
1005 ;;
f2dc06a3 1006 -n|--summary-limit)
862ae6cd
RS
1007 summary_limit="$2"
1008 isnumber "$summary_limit" || usage
f2dc06a3
PY
1009 shift
1010 ;;
862ae6cd
RS
1011 --summary-limit=*)
1012 summary_limit="${1#--summary-limit=}"
1013 isnumber "$summary_limit" || usage
1014 ;;
28f9af5d
PY
1015 --)
1016 shift
1017 break
1018 ;;
1019 -*)
1020 usage
1021 ;;
1022 *)
1023 break
1024 ;;
1025 esac
1026 shift
1027 done
bffe71f4 1028
f2dc06a3
PY
1029 test $summary_limit = 0 && return
1030
3deea89c 1031 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
1032 then
1033 head=$rev
caa9c3ca 1034 test $# = 0 || shift
3deea89c
JH
1035 elif test -z "$1" -o "$1" = "HEAD"
1036 then
14e940d7
JH
1037 # before the first commit: compare with an empty tree
1038 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 1039 test -z "$1" || shift
28f9af5d 1040 else
3deea89c 1041 head="HEAD"
28f9af5d
PY
1042 fi
1043
1c244f6e
JL
1044 if [ -n "$files" ]
1045 then
1046 test -n "$cached" &&
465d6a00 1047 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
1048 diff_cmd=diff-files
1049 head=
1050 fi
1051
28f9af5d 1052 cd_to_toplevel
091a6eb0 1053 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 1054 # Get modified modules cared by user
18076502 1055 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 1056 sane_egrep '^:([0-7]* )?160000' |
2be94509 1057 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
1058 do
1059 # Always show modules deleted or type-changed (blob<->module)
2be94509 1060 test $status = D -o $status = T && echo "$sm_path" && continue
927b26f8 1061 # Respect the ignore setting for --for-status.
1062 if test -n "$for_status"
1063 then
1064 name=$(module_name "$sm_path")
1065 ignore_config=$(get_submodule_config "$name" ignore none)
1066 test $status != A -a $ignore_config = all && continue
1067 fi
28f9af5d 1068 # Also show added or modified modules which are checked out
2be94509 1069 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1070 echo "$sm_path"
28f9af5d
PY
1071 done
1072 )
1cb639e6 1073
d0f64dd4
PY
1074 test -z "$modules" && return
1075
18076502 1076 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 1077 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
1078 cut -c2- |
1079 while read mod_src mod_dst sha1_src sha1_dst status name
1080 do
1081 if test -z "$cached" &&
1082 test $sha1_dst = 0000000000000000000000000000000000000000
1083 then
1084 case "$mod_dst" in
1085 160000)
1086 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1087 ;;
1088 100644 | 100755 | 120000)
1089 sha1_dst=$(git hash-object $name)
1090 ;;
1091 000000)
1092 ;; # removed
1093 *)
1094 # unexpected type
6ff875c5 1095 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
1096 continue ;;
1097 esac
1098 fi
1099 missing_src=
1100 missing_dst=
1101
1102 test $mod_src = 160000 &&
30353a40 1103 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
1104 missing_src=t
1105
1106 test $mod_dst = 160000 &&
30353a40 1107 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 1108 missing_dst=t
bffe71f4 1109
091a6eb0
JK
1110 display_name=$(relative_path "$name")
1111
1cb639e6
PY
1112 total_commits=
1113 case "$missing_src,$missing_dst" in
1114 t,)
091a6eb0 1115 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
1116 ;;
1117 ,t)
091a6eb0 1118 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
1119 ;;
1120 t,t)
091a6eb0 1121 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
1122 ;;
1123 *)
1124 errmsg=
1125 total_commits=$(
1126 if test $mod_src = 160000 -a $mod_dst = 160000
1127 then
1128 range="$sha1_src...$sha1_dst"
1129 elif test $mod_src = 160000
1130 then
1131 range=$sha1_src
1132 else
1133 range=$sha1_dst
1134 fi
1135 GIT_DIR="$name/.git" \
b0e621ad 1136 git rev-list --first-parent $range -- | wc -l
1cb639e6 1137 )
eed35595 1138 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
1139 ;;
1140 esac
1141
1142 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1143 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1144 if test $status = T
1145 then
b3e73449
ÆAB
1146 blob="$(gettext "blob")"
1147 submodule="$(gettext "submodule")"
1cb639e6
PY
1148 if test $mod_dst = 160000
1149 then
091a6eb0 1150 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 1151 else
091a6eb0 1152 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1153 fi
1154 else
091a6eb0 1155 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1156 fi
1157 if test -n "$errmsg"
1158 then
1159 # Don't give error msg for modification whose dst is not submodule
1160 # i.e. deleted or changed to blob
1161 test $mod_dst = 160000 && echo "$errmsg"
1162 else
1163 if test $mod_src = 160000 -a $mod_dst = 160000
1164 then
f2dc06a3
PY
1165 limit=
1166 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1167 GIT_DIR="$name/.git" \
f2dc06a3 1168 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1169 --first-parent $sha1_src...$sha1_dst
1170 elif test $mod_dst = 160000
1171 then
1172 GIT_DIR="$name/.git" \
1173 git log --pretty='format: > %s' -1 $sha1_dst
1174 else
1175 GIT_DIR="$name/.git" \
1176 git log --pretty='format: < %s' -1 $sha1_src
1177 fi
1178 echo
1179 fi
1180 echo
3ba7407b 1181 done
28f9af5d 1182}
70c7ac22 1183#
941987a5 1184# List all submodules, prefixed with:
70c7ac22
LH
1185# - submodule not initialized
1186# + different revision checked out
1187#
1188# If --cached was specified the revision in the index will be printed
1189# instead of the currently checked out revision.
1190#
1191# $@ = requested paths (default to all)
1192#
23a485e3 1193cmd_status()
70c7ac22 1194{
5c08dbbd
JH
1195 # parse $args after "submodule ... status".
1196 while test $# -ne 0
1197 do
1198 case "$1" in
1199 -q|--quiet)
2e6a30ef 1200 GIT_QUIET=1
5c08dbbd
JH
1201 ;;
1202 --cached)
1203 cached=1
1204 ;;
64b19ffe
JH
1205 --recursive)
1206 recursive=1
1207 ;;
5c08dbbd
JH
1208 --)
1209 shift
1210 break
1211 ;;
1212 -*)
1213 usage
1214 ;;
1215 *)
1216 break
1217 ;;
1218 esac
1219 shift
1220 done
1221
a7b3269c 1222 module_list "$@" |
64394e3a 1223 while read mode sha1 stage sm_path
70c7ac22 1224 do
be9d0a3a 1225 die_if_unmatched "$mode"
64394e3a 1226 name=$(module_name "$sm_path") || exit
5be60078 1227 url=$(git config submodule."$name".url)
091a6eb0 1228 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1229 if test "$stage" = U
1230 then
1231 say "U$sha1 $displaypath"
1232 continue
1233 fi
64394e3a 1234 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
70c7ac22 1235 then
64b19ffe 1236 say "-$sha1 $displaypath"
70c7ac22
LH
1237 continue;
1238 fi
64394e3a 1239 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1240 then
b545cd15 1241 set_name_rev "$sm_path" "$sha1"
64b19ffe 1242 say " $sha1 $displaypath$revname"
70c7ac22
LH
1243 else
1244 if test -z "$cached"
1245 then
64394e3a 1246 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1247 fi
b545cd15 1248 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1249 say "+$sha1 $displaypath$revname"
1250 fi
1251
1252 if test -n "$recursive"
1253 then
1254 (
1255 prefix="$displaypath/"
74ae1419 1256 clear_local_git_env
64394e3a 1257 cd "$sm_path" &&
e15bec0e 1258 eval cmd_status
64b19ffe 1259 ) ||
64394e3a 1260 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1261 fi
1262 done
1263}
2327f61e
DA
1264#
1265# Sync remote urls for submodules
1266# This makes the value for remote.$remote.url match the value
1267# specified in .gitmodules.
1268#
1269cmd_sync()
1270{
1271 while test $# -ne 0
1272 do
1273 case "$1" in
1274 -q|--quiet)
2e6a30ef 1275 GIT_QUIET=1
2327f61e
DA
1276 shift
1277 ;;
82f49f29
PH
1278 --recursive)
1279 recursive=1
1280 shift
1281 ;;
2327f61e
DA
1282 --)
1283 shift
1284 break
1285 ;;
1286 -*)
1287 usage
1288 ;;
1289 *)
1290 break
1291 ;;
1292 esac
1293 done
1294 cd_to_toplevel
1295 module_list "$@" |
64394e3a 1296 while read mode sha1 stage sm_path
2327f61e 1297 do
be9d0a3a 1298 die_if_unmatched "$mode"
64394e3a 1299 name=$(module_name "$sm_path")
2327f61e 1300 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1301
1302 # Possibly a url relative to parent
1303 case "$url" in
1304 ./*|../*)
967b2c66
JS
1305 # rewrite foo/bar as ../.. to find path from
1306 # submodule work tree to superproject work tree
1307 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1308 # guarantee a trailing /
1309 up_path=${up_path%/}/ &&
1310 # path from submodule work tree to submodule origin repo
1311 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1312 # path from superproject work tree to submodule origin repo
1313 super_config_url=$(resolve_relative_url "$url") || exit
1314 ;;
1315 *)
1316 sub_origin_url="$url"
1317 super_config_url="$url"
baede9f8
JH
1318 ;;
1319 esac
1320
ccee6086 1321 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1322 then
091a6eb0
JK
1323 displaypath=$(relative_path "$prefix$sm_path")
1324 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1325 git config submodule."$name".url "$super_config_url"
ccee6086 1326
64394e3a 1327 if test -e "$sm_path"/.git
ccee6086
JH
1328 then
1329 (
1330 clear_local_git_env
64394e3a 1331 cd "$sm_path"
ccee6086 1332 remote=$(get_default_remote)
967b2c66 1333 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1334
1335 if test -n "$recursive"
1336 then
1337 prefix="$prefix$sm_path/"
1338 eval cmd_sync
1339 fi
ccee6086
JH
1340 )
1341 fi
2327f61e
DA
1342 fi
1343 done
1344}
70c7ac22 1345
5c08dbbd
JH
1346# This loop parses the command line arguments to find the
1347# subcommand name to dispatch. Parsing of the subcommand specific
1348# options are primarily done by the subcommand implementations.
1349# Subcommand specific options such as --branch and --cached are
1350# parsed here as well, for backward compatibility.
1351
1352while test $# != 0 && test -z "$command"
70c7ac22
LH
1353do
1354 case "$1" in
cf419828 1355 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1356 command=$1
70c7ac22
LH
1357 ;;
1358 -q|--quiet)
2e6a30ef 1359 GIT_QUIET=1
70c7ac22 1360 ;;
ecda0723
SV
1361 -b|--branch)
1362 case "$2" in
1363 '')
1364 usage
1365 ;;
1366 esac
1367 branch="$2"; shift
1368 ;;
70c7ac22 1369 --cached)
28f9af5d 1370 cached="$1"
70c7ac22
LH
1371 ;;
1372 --)
1373 break
1374 ;;
1375 -*)
1376 usage
1377 ;;
1378 *)
1379 break
1380 ;;
1381 esac
1382 shift
1383done
1384
5c08dbbd 1385# No command word defaults to "status"
af9c9f97
RR
1386if test -z "$command"
1387then
1388 if test $# = 0
1389 then
1390 command=status
1391 else
1392 usage
1393 fi
1394fi
5c08dbbd
JH
1395
1396# "-b branch" is accepted only by "add"
1397if test -n "$branch" && test "$command" != add
1398then
ecda0723 1399 usage
5c08dbbd
JH
1400fi
1401
28f9af5d
PY
1402# "--cached" is accepted only by "status" and "summary"
1403if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 1404then
70c7ac22 1405 usage
5c08dbbd
JH
1406fi
1407
1408"cmd_$command" "$@"